// Thanks to https://www.shadertoy.com/view/MdlXz8

#define TAU 6.28318530718
#define MAX_ITER 3

vec4 ProcessTexel() {
	vec2 texCoord = vTexCoord.st;

	float time = timer * .5 + 23.0;
  vec2 iResolution = vec2(1.5, 1.5);

  // uv should be the 0-1 uv of texture...
  vec2 uv = texCoord.xy / iResolution.xy;

  vec2 p = mod(uv * TAU, TAU) - 250.0;
  vec2 i = vec2(p);
  float c = 1.0;
  float inten = .005;

  for (int n = 0; n < MAX_ITER; n++) {
    float t = time * (1.0 - (3.5 / float(n + 1)));
    i = p + vec2(cos(t - i.x) + sin(t + i.y), sin(t - i.y) + cos(t + i.x));
    c += 1.0 / length(vec2(p.x / (sin(i.x + t) / inten), p.y / (cos(i.y + t) / inten)));
  }

  c /= float(MAX_ITER);
  c = 1.17 - pow(c, 1.4);
  float q = pow(abs(c), 8.0);
  vec4 colour = vec4(q, q, q, 1.0) * 0.25;

  return clamp(colour + getTexel(texCoord), 0.0, 1.0);
}
